SMIME_write_PKCS7(3)

NAME
SMIME_write_PKCS7 - convert PKCS#7 structure to S/MIME format.

LIBRARY
libcrypto, -lcrypto

SYNOPSIS
 #include <openssl/pkcs7.h>

 int SMIME_write_PKCS7(BIO *out, PKCS7 *p7, BIO *data, int flags);

DESCRIPTION
SMIME_write_PKCS7() adds the appropriate MIME headers to a PKCS#7 structure to produce an S/MIME message.

out is the BIO to write the data to. p7 is the appropriate PKCS7 structure. If streaming is enabled then the content must be supplied in the data argument. flags is an optional set of flags.

NOTES
The following flags can be passed in the flags parameter.

If PKCS7_DETACHED is set then cleartext signing will be used, this option only makes sense for signedData where PKCS7_DETACHED is also set when PKCS7_sign() is also called.

If the PKCS7_TEXT flag is set MIME headers for type text/plain are added to the content, this only makes sense if PKCS7_DETACHED is also set.

If the PKCS7_STREAM flag is set streaming is performed. This flag should only be set if PKCS7_STREAM was also set in the previous call to PKCS7_sign() or PKCS7_encrypt().

If cleartext signing is being used and PKCS7_STREAM not set then the data must be read twice: once to compute the signature in PKCS7_sign() and once to output the S/MIME message.

If streaming is performed the content is output in BER format using indefinite length constructuted encoding except in the case of signed data with detached content where the content is absent and DER format is used.

BUGS
SMIME_write_PKCS7() always base64 encodes PKCS#7 structures, there should be an option to disable this.

RETURN VALUES
SMIME_write_PKCS7() returns 1 for success or 0 for failure.

SEE ALSO
ERR_get_error(3), PKCS7_sign(3), PKCS7_verify(3), PKCS7_encrypt(3) PKCS7_decrypt(3)

HISTORY
SMIME_write_PKCS7() was added to OpenSSL 0.9.5